package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.WorldCreator;
import org.bukkit.configuration.file.FileConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class WorldManager {

    private Raxen main;
    private static StorageManager sto;

    @Getter
    private HashMap<String, World> worlds = new HashMap<>();

    public WorldManager(Raxen main) {
        this.main = main;
        this.sto = main.getStorageManager();
        if(!(new File(main.getDataFolder() + "/Worlds/").exists())) {
            new File(main.getDataFolder() + "/Worlds/").mkdirs();
        }
    }

    public void save() {
        String path = main.getDataFolder() + "/Worlds/";
        File folder = new File(path);
        List<World> worlds = Bukkit.getWorlds();
        for (World world : worlds) {
            File file = new File(path + world.getName() + ".yml");
            FileConfiguration fileConf = sto.createYml(file);
            fileConf.set("name", world.getName());
            fileConf.set("uuid", world.getUID().toString());
            try {
                fileConf.save(file);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public void saveWorld(String name) {
        World world = Bukkit.getWorld(name);
        UUID uuid = world.getUID();
        String key = world.getKey().getKey();
        File file = new File(main.getDataFolder() + "/Worlds/" + name + ".yml");
    }

    public void load() {
        String path = main.getDataFolder() + "/Worlds/";
        File folder = new File(path);
        File[] listFile = folder.listFiles();
        for (File file : listFile) {
            loadWorld(file);
        }
    }

    public World loadWorld(File file) {
        FileConfiguration fileConf = sto.createYml(file);
        World world = Bukkit.createWorld(new WorldCreator(fileConf.getString("name")));
        worlds.put(world.getName(), world);
        return world;
    }

    public World getWorld(String name) {
        return Bukkit.getWorld(name);
    }
}
